﻿Imports System

Namespace ServerREC
    Class cVaxCallSession

        Private m_objAccessPCM As cVaxAccessAudioPCM = Nothing
        Private m_objDetectVAD As cVaxDetectAudioVAD = Nothing

        Public Sub New()
            m_objAccessPCM = New cVaxAccessAudioPCM()
            m_objDetectVAD = New cVaxDetectAudioVAD()
        End Sub

        '///////////////////////////////////////////////////////////////////////////////////////////
        '///////////////////////////////////////////////////////////////////////////////////////////
        Public Sub OnCallSessionClosed(nSessionId As Integer, nReasonCode As Integer)
            m_objAccessPCM.OnCallSessionClosed(nSessionId)
            m_objDetectVAD.OnCallSessionClosed(nSessionId)
        End Sub

        '///////////////////////////////////////////////////////////////////////////////////////////
        '///////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnIncomingCall(nSessionId As Integer, sCallerName As String, sCallerId As String, sCalleeName As String, sCalleeId As String, sDialNo As String, nFromPeerType As Integer, sFromPeerName As String, sUserAgentName As String, sRecXML As String, sFromIP As String, nFromPort As Integer)
            AcceptCallSession(nSessionId)
        End Sub

        Private Function AcceptCallSession(nSessionId As Integer) As Boolean

            Dim bResult As Boolean = cVaxServerREC.mVaxREC.AcceptCallSession(nSessionId)

            If Not bResult Then
                cVaxServerREC.mVaxREC.RejectCallSession(nSessionId, 404, "Not Found")
                Return False
            End If

            Return True

        End Function

        '///////////////////////////////////////////////////////////////////////////////////////////
        '///////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnCallSessionConnected(nSessionId As Integer)

            StartRecording(nSessionId)

            m_objAccessPCM.OnCallSessionConnected(nSessionId)
            m_objDetectVAD.OnCallSessionConnected(nSessionId)

        End Sub

        Private Sub StartRecording(nSessionId As Integer)

            Dim sDefaultRecPath As String = cVaxServerREC.mVaxREC.GetRecordingFolder()
            Dim objGenFileLoc As New cGenFileLocation()
            Dim sRecFilePath As String = objGenFileLoc.GenRecordingFilePath(nSessionId, sDefaultRecPath)

            If sRecFilePath.Length = 0 Then
                Dim sErrorMsg As String = String.Format("[SessionId:{0}] [Error Msg: {1}]", nSessionId, cVaxDefine.ERROR_REC_FILE_NOT_FOUND)
                cVaxServerREC.mVaxREC.GenStatusLog(sErrorMsg)
                Return
            End If

            cVaxServerREC.mVaxREC.RecordWaveStartToCallSession(nSessionId, sRecFilePath)

        End Sub

        '///////////////////////////////////////////////////////////////////////////////////////////
        '///////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnCallSessionAccessAudioPCM(nSessionId As Integer, nAccessType As Integer, aDataPCM As Byte(), nSizePCM As Integer)
            m_objAccessPCM.OnCallSessionAccessAudioPCM(nSessionId, nAccessType, aDataPCM, nSizePCM)
        End Sub

        '///////////////////////////////////////////////////////////////////////////////////////////
        '///////////////////////////////////////////////////////////////////////////////////////////
        Public Sub OnCallSessionMediaDetectStartedVAD(ByVal nSessionId As Integer)
            m_objDetectVAD.OnCallSessionMediaDetectStartedVAD(nSessionId)
        End Sub

        Public Sub OnCallSessionMediaDetectCompletedVAD(ByVal nSessionId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
            m_objDetectVAD.OnCallSessionMediaDetectCompletedVAD(nSessionId, aDataPCM, nSizePCM, nTypePCM)
        End Sub

        Public Sub OnCallSessionMediaDetectExpiredVAD(ByVal nSessionId As Integer)
            m_objDetectVAD.OnCallSessionMediaDetectExpiredVAD(nSessionId)
        End Sub

    End Class

End Namespace
