﻿Imports System
Imports System.Collections

Namespace ServerREC

    Class cStoreUser

        Const USER_ROOT_PATH As String = "Users\"

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddUser(ByVal sUserName As String, ByVal sPassword As String, ByVal sAudioCodecList As String) As Boolean

            If sUserName.Length = 0 Then Return False

            Dim sKeyPath As String = USER_ROOT_PATH & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.SetTEXT(sKeyPath, "UserName", sUserName)
            objStore.SetTEXT(sKeyPath, "Password", sPassword)

            objStore.SetTEXT(sKeyPath, "AudioCodecList", sAudioCodecList)
            objStore.Close()

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetUser(ByVal sUserName As String, ByRef sPassword As String, ByRef sAudioCodecList As String)

            Dim sKeyPath As String = USER_ROOT_PATH & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.GetTEXT(sKeyPath, "Password", sPassword, "")
            objStore.GetTEXT(sKeyPath, "AudioCodecList", sAudioCodecList, "")

            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveUser(ByVal sUserName As String)

            If sUserName.Length = 0 Then Return

            Dim sKeyPath As String = USER_ROOT_PATH & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.DeleteSubKey(sKeyPath)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetUserAll(ByRef objList As ArrayList)

            Dim sKeyPath As String = USER_ROOT_PATH
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.EnumSubKeys(sKeyPath, objList)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function IsDataStored() As Boolean

            Dim objStore As cStoreRegistry = New cStoreRegistry()
            Dim bResult As Boolean = objStore.IsKeyExist(USER_ROOT_PATH)

            objStore.Close()
            Return bResult

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
