
// TestSocket.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "VaxPipeClient.h"

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

CVaxPipeClient::CVaxPipeClient()
{
	m_hHandlePipe = NULL;
	m_hWaitEvent = NULL;
}

CVaxPipeClient::~CVaxPipeClient()
{

}

BOOLEAN CVaxPipeClient::CreatePipe(LPCTSTR sPipeName)
{
    m_hHandlePipe = ::CreateFile(sPipeName, GENERIC_READ | FILE_WRITE_ATTRIBUTES, 0, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);

    if (m_hHandlePipe == INVALID_HANDLE_VALUE)
    {
        if (::GetLastError() != ERROR_PIPE_BUSY)
            return FALSE;

        if (!::WaitNamedPipe(sPipeName, 3000))
            return FALSE;
    }

    DWORD dwMode = PIPE_READMODE_MESSAGE;

    ::SetNamedPipeHandleState(m_hHandlePipe, &dwMode, NULL, NULL);

    m_hWaitEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

    if (m_hWaitEvent == NULL)
    {
        ClosePipe();
        return FALSE;
    }
    
    return TRUE;
}

void CVaxPipeClient::ClosePipe()
{
    if (m_hHandlePipe != NULL)
    {
        ::CloseHandle(m_hHandlePipe);
        m_hHandlePipe = 0;
    }

    if (m_hWaitEvent != NULL)
    {
        ::CloseHandle(m_hWaitEvent);
        m_hWaitEvent = 0;
    }
}

BOOLEAN CVaxPipeClient::BeginReadPipe(HANDLE& hWaitEvent)
{
    ::memset(&m_objOverLap, 0, sizeof(OVERLAPPED));
    m_objOverLap.hEvent = m_hWaitEvent;

    DWORD dwSizeRead = 0;

    BOOLEAN bResult = ReadFile(m_hHandlePipe, m_aDataReadPipe, VAX_PIPE_CLIENT_BUFFER_LENGTH, &dwSizeRead, &m_objOverLap);
    
    if ((bResult == FALSE) && (::GetLastError() != ERROR_IO_PENDING))
        return FALSE;

    //if ((bResult == FALSE) && (::GetLastError() != ERROR_MORE_DATA))
        //return FALSE;

    hWaitEvent = m_hWaitEvent;
    return TRUE;
}

BOOLEAN CVaxPipeClient::EndReadPipe(char* pDataRead, int& nSizeRead)
{
    DWORD dwSizeRead = 0;

    if (!::GetOverlappedResult(m_hHandlePipe, &m_objOverLap, &dwSizeRead, FALSE))
        return FALSE;

    nSizeRead = dwSizeRead;

    if(dwSizeRead != 0)
        ::memcpy(pDataRead, m_aDataReadPipe, dwSizeRead);

    return TRUE;
}
