#include "StdAfx.h"
#include "VaxServerCOM.h"
#include <afxctl.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C"{
#endif 

#ifndef __IID_DEFINED__
#define __IID_DEFINED__

typedef struct _IID
{
    unsigned long x;
    unsigned short s1;
    unsigned short s2;
    unsigned char  c[8];
} IID;

#endif // __IID_DEFINED__

#ifndef CLSID_DEFINED
#define CLSID_DEFINED
typedef IID CLSID;
#endif // CLSID_DEFINED

const IID LIBID_VAXTELESERVERRECLib = {0x9F672746,0x8CBC,0x4311,{0x9C,0x49,0x99,0x10,0xCA,0x41,0xC8,0x3A}};
const IID DIID__IVaxServerRECEvents = {0xF8888D1E,0xA110,0x430C,{0x83,0xB7,0xCF,0xBC,0x0E,0x68,0x5A,0x08}};
const IID IID_IVaxServerREC         = {0x50E5EAE5,0x129A,0x4B98,{0x8A,0x0D,0xAE,0xAE,0x84,0xD5,0x5C,0x06}};
const CLSID CLSID_VaxServerREC      = {0x147D0C8C,0x750A,0x4977,{0xAC,0x25,0xE6,0x05,0x20,0x45,0x27,0xAE}};

#ifdef __cplusplus
}
#endif

IMPLEMENT_DYNCREATE(CVaxServerCOM, CCmdTarget)

CVaxServerCOM::CVaxServerCOM()
{
	EnableAutomation();
			
	m_pVaxREC = NULL;
	m_pVaxEventsREC = NULL;

	LoadCOM();
}

CVaxServerCOM::~CVaxServerCOM()
{
	UnLoadCOM();
}


void CVaxServerCOM::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CVaxServerCOM, CCmdTarget)
	//{{AFX_MSG_MAP(CVaxServerCOM)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CVaxServerCOM, CCmdTarget)

	DISP_FUNCTION(CVaxServerCOM, "OnRegisterUser", OnRegisterUser, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnRegisterUserSuccess", OnRegisterUserSuccess, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnRegisterUserFailed", OnRegisterUserFailed, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnUnRegisterUser", OnUnRegisterUser, VT_EMPTY, VTS_BSTR)

	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionCreated", OnCallSessionCreated, VT_EMPTY, VTS_I4 VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionClosed", OnCallSessionClosed, VT_EMPTY, VTS_I4 VTS_I4) 

	DISP_FUNCTION(CVaxServerCOM, "OnIncomingCall", OnIncomingCall, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionConnected", OnCallSessionConnected, VT_EMPTY, VTS_I4)
		
	DISP_FUNCTION(CVaxServerCOM, "OnLineRegisterTrying", OnLineRegisterTrying, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineRegisterFailed", OnLineRegisterFailed, VT_EMPTY, VTS_BSTR VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineRegisterSuccess", OnLineRegisterSuccess, VT_EMPTY, VTS_BSTR)
	
	DISP_FUNCTION(CVaxServerCOM, "OnLineUnRegisterTrying", OnLineUnRegisterTrying, VT_EMPTY, VTS_BSTR )
	DISP_FUNCTION(CVaxServerCOM, "OnLineUnRegisterFailed", OnLineUnRegisterFailed, VT_EMPTY, VTS_BSTR VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineUnRegisterSuccess", OnLineUnRegisterSuccess, VT_EMPTY, VTS_BSTR)

	DISP_FUNCTION(CVaxServerCOM, "OnOutgoingDiagnosticLog", OnOutgoingDiagnosticLog, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnIncomingDiagnosticLog", OnIncomingDiagnosticLog, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4) 

	DISP_FUNCTION(CVaxServerCOM, "OnVaxServerTick", OnVaxServerTick, VT_EMPTY, VTS_I4)

	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionLost", OnCallSessionLost, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionHangup", OnCallSessionHangup, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTimeout", OnCallSessionTimeout, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionCancelled", OnCallSessionCancelled, VT_EMPTY, VTS_I4)
	
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionRecordedWaveREC", OnCallSessionRecordedWaveREC, VT_EMPTY, VTS_I4 VTS_I8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnVaxLicenseChannel", OnVaxLicenseChannel, VT_EMPTY, VTS_I4 VTS_I4)

	DISP_FUNCTION(CVaxServerCOM, "OnVaxErrorLog", OnVaxErrorLog, VT_EMPTY, VTS_BSTR VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionErrorLog", OnCallSessionErrorLog, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
	
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionAccessAudioPCM", OnCallSessionAccessAudioPCM, VT_EMPTY, VTS_I4 VTS_I4 VTS_I8 VTS_I4 VTS_I4)

	DISP_FUNCTION(CVaxServerCOM, "OnAttackDetectedScanSIP", OnAttackDetectedScanSIP, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnAttackDetectedFloodSIP", OnAttackDetectedFloodSIP, VT_EMPTY, VTS_BSTR VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnAttackDetectedBruteForceSIP", OnAttackDetectedBruteForceSIP, VT_EMPTY, VTS_BSTR VTS_I4 VTS_BSTR VTS_I4 VTS_I4)

	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionMediaDetectStartedVAD", OnCallSessionMediaDetectStartedVAD, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionMediaDetectCompletedVAD", OnCallSessionMediaDetectCompletedVAD, VT_EMPTY, VTS_I4 VTS_I8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionMediaDetectExpiredVAD", OnCallSessionMediaDetectExpiredVAD, VT_EMPTY, VTS_I4)
		
END_DISPATCH_MAP()

// Note: we add support for IID_IVaxServerSIP to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {3DB0F857-BB81-4371-A80C-C4CB971721D1}
//static const IID IID_IVaxServerSIP =
//{ 0x3db0f857, 0xbb81, 0x4371, { 0xa8, 0xc, 0xc4, 0xcb, 0x97, 0x17, 0x21, 0xd1 } };

BEGIN_INTERFACE_MAP(CVaxServerCOM, CCmdTarget)
	INTERFACE_PART(CVaxServerCOM, DIID__IVaxServerRECEvents, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVaxServerCOM message handlers

void CVaxServerCOM::UnLoadCOM()
{
	if(m_pVaxREC)
	{
		m_pVaxREC->Release();
		m_pVaxREC = NULL;
	}

	if(m_pVaxEventsREC)
	{
		LPUNKNOWN pUnk = GetIDispatch(FALSE);
		AfxConnectionUnadvise(m_pVaxEventsREC , DIID__IVaxServerRECEvents, pUnk, FALSE, m_dwCookie);

		m_pVaxEventsREC->Release();
		m_pVaxEventsREC = NULL;
	}
}

BOOL CVaxServerCOM::LoadCOM()
{
	UnLoadCOM();

	CoInitialize(NULL);
	
	HRESULT hr = CoCreateInstance(CLSID_VaxServerREC, NULL, CLSCTX_INPROC_SERVER, IID_IDispatch, (void**) &m_pVaxEventsREC);
	if(FAILED(hr)) return FALSE;

	m_pVaxEventsREC->QueryInterface(IID_IVaxServerREC, (void**) &m_pVaxREC);
	
	m_dwCookie = 1;
		
	LPUNKNOWN pUnk = GetIDispatch(FALSE);

	if(!AfxConnectionAdvise(m_pVaxEventsREC, DIID__IVaxServerRECEvents, pUnk, FALSE, &m_dwCookie))
	{
		return FALSE;
	}

	return TRUE;
}

#define VAX_ERROR_LOAD_COM	"Unable to load VaxTeleServerCOM.dll COM component. Run command prompt as administrator, register the COM using regsvr32 command and try again.\n\n e.g. regsvr32 VaxTeleServerCOM.dll"

BOOL CVaxServerCOM::IsLoadedCOM()
{
	if(m_pVaxREC)
		return TRUE;
				
	OnVaxErrorLog("", -1, VAX_ERROR_LOAD_COM);
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::GetVaxErrorCode()
{
	if(!IsLoadedCOM())
		return 0;

	return m_pVaxREC->GetVaxErrorCode();
}

CString CVaxServerCOM::GetVaxErrorText()
{
	if(!IsLoadedCOM())
		return "";

	return CString((BSTR) m_pVaxREC->GetVaxErrorText());
}

void CVaxServerCOM::SetLicenseKey(LPCTSTR sLicenseKey)
{
	if(!IsLoadedCOM())
		return;

	m_pVaxREC->SetLicenseKey(sLicenseKey);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::Initialize(LPCTSTR sDomainRealm)
{
	if(!IsLoadedCOM())
	{
		AfxMessageBox(VAX_ERROR_LOAD_COM);
		return FALSE;
	}
	
	return m_pVaxREC->Initialize(sDomainRealm);
}

void CVaxServerCOM::UnInitialize()
{	
	if(m_pVaxREC)
		m_pVaxREC->UnInitialize();
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
    
BOOL CVaxServerCOM::CryptoMediaNONE(BOOL bForced)
{
	return m_pVaxREC->CryptoMediaNONE(bForced);
}

BOOL CVaxServerCOM::CryptoMediaSDP(BOOL bForced)
{
	return m_pVaxREC->CryptoMediaSDP(bForced);
}
    
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::OpenNetworkUDP(LPCTSTR sListenIP, LONG nListenPort)
{
	if(!IsLoadedCOM())
	{
		AfxMessageBox(VAX_ERROR_LOAD_COM);
		return FALSE;
	}
	
	return m_pVaxREC->OpenNetworkUDP(sListenIP, nListenPort);
}

BOOL CVaxServerCOM::OpenNetworkTCP(LPCTSTR sListenIP, LONG nListenPort)
{
	if(!IsLoadedCOM())
	{
		AfxMessageBox(VAX_ERROR_LOAD_COM);
		return FALSE;
	}
	
	return m_pVaxREC->OpenNetworkTCP(sListenIP, nListenPort);
}

BOOL CVaxServerCOM::OpenNetworkTLS(LPCTSTR sListenIP, LONG nListenPort, LPCTSTR sCertPEM)
{
	if(!IsLoadedCOM())
	{
		AfxMessageBox(VAX_ERROR_LOAD_COM);
		return FALSE;
	}
	
	return m_pVaxREC->OpenNetworkTLS(sListenIP, nListenPort, sCertPEM);
}

void CVaxServerCOM::CloseNetworkUDP()
{
	if(!IsLoadedCOM())
		return;
		
	m_pVaxREC->CloseNetworkUDP();
}

void CVaxServerCOM::CloseNetworkTCP()
{
	if(!IsLoadedCOM())
		return;
		
	m_pVaxREC->CloseNetworkTCP();
}

void CVaxServerCOM::CloseNetworkTLS()
{
	if(!IsLoadedCOM())
		return;
		
	m_pVaxREC->CloseNetworkTLS();
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::SetListenPortRangeRTP(LONG nListenStartPort, LONG nListenEndPort)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->SetListenPortRangeRTP(nListenStartPort, nListenEndPort);
}

BOOL CVaxServerCOM::SetNetworkMediaRTP(LPCTSTR sListenIP, LONG nListenStartPort)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->SetNetworkMediaRTP(sListenIP, nListenStartPort);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sAudioCodecList)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AddUser(sUserName, sPassword, sAudioCodecList);
}

void CVaxServerCOM::RemoveUser(LPCTSTR sUserName)
{
	if(!IsLoadedCOM())
		return;

	m_pVaxREC->RemoveUser(sUserName);
}

BOOL CVaxServerCOM::RegisterUserExpiry(LONG nExpiry)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->RegisterUserExpiry(nExpiry);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AcceptRegister(LONG nRegId)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AcceptRegister(nRegId);
}

BOOL CVaxServerCOM::RejectRegister(LONG nRegId, LONG nStatusCode, LPCTSTR sReasonPhrase)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->RejectRegister(nRegId, nStatusCode, sReasonPhrase);
}

BOOL CVaxServerCOM::AuthRegister(LONG nRegId)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AuthRegister(nRegId);
}

BOOL CVaxServerCOM::AttachRegister(LONG nRegId, LPCTSTR sUserName)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AttachRegister(nRegId, sUserName);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddLine(LPCTSTR sLineName, LONG nLineType, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sServerAddr, LONG nServerPort, LPCTSTR sAudioCodecList)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AddLine(sLineName, nLineType, sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort, sAudioCodecList);
}

void CVaxServerCOM::RemoveLine(LPCTSTR sLineName)
{
	if(!IsLoadedCOM())
		return;

	m_pVaxREC->RemoveLine(sLineName);
}

BOOL CVaxServerCOM::RegisterLine(LPCTSTR sLineName, LONG nExpire)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->RegisterLine(sLineName, nExpire);
}

BOOL CVaxServerCOM::UnRegisterLine(LPCTSTR sLineName)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->UnRegisterLine(sLineName);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AcceptCallSession(LONG nSessionId, LONG nTimeout)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AcceptCallSession(nSessionId, nTimeout);
}

BOOL CVaxServerCOM::RejectCallSession(LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->RejectCallSession(nSessionId, nStatusCode, sReasonPhrase);
}

BOOL CVaxServerCOM::CloseCallSession(LONG nSessionId)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->CloseCallSession(nSessionId);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::RecordWaveSetCacheSize(LONG nCacheSize)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->RecordWaveSetCacheSize(nCacheSize);
}

BOOL CVaxServerCOM::RecordWaveStartToCallSession(LONG nSessionId, LPCTSTR sFileName, LONG nTypeREC)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->RecordWaveStartToCallSession(nSessionId, sFileName, nTypeREC);
}

void CVaxServerCOM::RecordWaveStopToCallSession(LONG nSessionId)
{
	if(!IsLoadedCOM())
		return;

	m_pVaxREC->RecordWaveStopToCallSession(nSessionId);
}

BOOL CVaxServerCOM::RecordWavePauseToCallSession(LONG nSessionId, BOOL bEnable)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->RecordWavePauseToCallSession(nSessionId, bEnable);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AudioSessionLost(BOOL bEnable, LONG nTimeout)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AudioSessionLost(bEnable, nTimeout);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::VaxServerStartTick(LONG nTickId, LONG nElapse)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->VaxServerStartTick(nTickId, nElapse);
}

BOOL CVaxServerCOM::VaxServerStopTick(LONG nTickId)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->VaxServerStopTick(nTickId);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::SetUserAgentName(LPCTSTR sName)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->SetUserAgentName(sName);
}

CString CVaxServerCOM::GetUserAgentName()
{
	if(!IsLoadedCOM())
		return "";

	return CString((BSTR) m_pVaxREC->GetUserAgentName());
}
	
/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::SetSessionNameSDP(LPCTSTR sName)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->SetSessionNameSDP(sName);
}

CString CVaxServerCOM::GetSessionNameSDP()
{
	if(!IsLoadedCOM())
		return "";

	return CString((BSTR) m_pVaxREC->GetSessionNameSDP());
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::DiagnosticLogSIP(BOOL bInbound, BOOL bOutbound)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->DiagnosticLogSIP(bInbound, bOutbound);
}

BOOL CVaxServerCOM::CallSessionSendStatusResponse(LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sContactURI)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, sContactURI);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddCustomHeader(LONG nReqId, LPCTSTR sName, LPCTSTR sValue)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AddCustomHeader(nReqId, sName, sValue);
}

BOOL CVaxServerCOM::RemoveCustomHeader(LONG nReqId, LPCTSTR sName)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->RemoveCustomHeader(nReqId, sName);
}

BOOL CVaxServerCOM::RemoveCustomHeaderAll(LONG nReqId)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->RemoveCustomHeaderAll(nReqId);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::GetCallSessionTxCodec(LONG nSessionId)
{
	if(!IsLoadedCOM())
		return -1;

	return m_pVaxREC->GetCallSessionTxCodec(nSessionId);
}

LONG CVaxServerCOM::GetCallSessionRxCodec(LONG nSessionId)
{
	if(!IsLoadedCOM())
		return -1;

	return m_pVaxREC->GetCallSessionRxCodec(nSessionId);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::GetCallCount()
{
	if(!IsLoadedCOM())
		return 0;

	return m_pVaxREC->GetCallCount();
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

CString CVaxServerCOM::GetCallSessionHeaderCallId(LONG nSessionId)
{
	if(!IsLoadedCOM())
		return "";

	return CString((BSTR) m_pVaxREC->GetCallSessionHeaderCallId(nSessionId));
}

BOOL CVaxServerCOM::CallSessionMuteVoice(LONG nSessionId, BOOL bListen, BOOL bSpeak)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->CallSessionMuteVoice(nSessionId, bListen, bSpeak);
}

CString CVaxServerCOM::GetUserAgentNameCall(LONG nSessionId)
{
	if (!IsLoadedCOM())
		return "";

	return CString((BSTR)m_pVaxREC->GetUserAgentNameCall(nSessionId));
}

LONG CVaxServerCOM::GetCallSessionPeerType(LONG nSessionId)
{
	if(!IsLoadedCOM())
		return -1;

	return m_pVaxREC->GetCallSessionPeerType(nSessionId);
}


CString CVaxServerCOM::GetCallSessionPeerName(LONG nSessionId)
{
	if(!IsLoadedCOM())
		return "";

	return CString((BSTR) m_pVaxREC->GetCallSessionPeerName(nSessionId));
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddNetworkRouteSIP(LPCTSTR sAssignedIP, LPCTSTR sRouterIP)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AddNetworkRouteSIP(sAssignedIP, sRouterIP);
}

BOOL CVaxServerCOM::AddNetworkRouteRTP(LPCTSTR sAssignedIP, LPCTSTR sRouterIP)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AddNetworkRouteRTP(sAssignedIP, sRouterIP);
}


BOOL CVaxServerCOM::AccessAudioPCM(LONG nSessionId, LPCTSTR sPipeName, LONG nAccessType)
{
	if(!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AccessAudioPCM(nSessionId, sPipeName, nAccessType);
}

BOOL CVaxServerCOM::AttackDetectScanSIP(LPCTSTR sDomainName)
{
	if (!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AttackDetectScanSIP(sDomainName);
}

BOOL CVaxServerCOM::AttackDetectFloodSIP(LONG nReqRecvLimit)
{
	if (!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AttackDetectFloodSIP(nReqRecvLimit);
}

BOOL CVaxServerCOM::AttackDetectBruteForceSIP(LONG nFailureCount, LONG nFailureInterval)
{
	if (!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->AttackDetectBruteForceSIP(nFailureCount, nFailureInterval);
}

BOOL CVaxServerCOM::DetectStartVAD(LONG nSessionId, LONG nAudioLevelVU, LONG nSilenceLengthPCM, LONG nSilenceCountPCM, LONG nAnalysisLengthPCM, LONG nExpiryLengthPCM, LONG nProcessLengthPCM, LONG nDetectType)
{
	if (!IsLoadedCOM())
		return FALSE;

	return m_pVaxREC->DetectStartVAD(nSessionId, nAudioLevelVU, nSilenceLengthPCM, nSilenceCountPCM, nAnalysisLengthPCM, nExpiryLengthPCM, nProcessLengthPCM, nDetectType);
}

void CVaxServerCOM::DetectStopVAD(LONG nSessionId)
{
	if (!IsLoadedCOM())
		return;

	m_pVaxREC->DetectStopVAD(nSessionId);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId) {}
void CVaxServerCOM::OnRegisterUserSuccess(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId) {}
void CVaxServerCOM::OnRegisterUserFailed(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId) {}
void CVaxServerCOM::OnUnRegisterUser(LPCTSTR sUserLogin) {}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sCalleeName, LPCTSTR sCalleeId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sUserAgent, LPCTSTR sRecXML, LPCTSTR sFromIP, UINT nFromPort){}
void CVaxServerCOM::OnCallSessionConnected(LONG nSessionId) {}

void CVaxServerCOM::OnCallSessionCreated(LONG nSessionId, LONG nReasonCode) {}
void CVaxServerCOM::OnCallSessionClosed(LONG nSessionId, LONG nReasonCode) {}

void CVaxServerCOM::OnCallSessionLost(LONG nSessionId) {}
void CVaxServerCOM::OnCallSessionHangup(LONG nSessionId) {}
void CVaxServerCOM::OnCallSessionTimeout(LONG nSessionId) {}
void CVaxServerCOM::OnCallSessionCancelled(LONG nSessionId) {}


/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnLineRegisterTrying(LPCTSTR sLineName){}

void CVaxServerCOM::OnLineRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnLineRegisterSuccess(LPCTSTR sLineName) {}

void CVaxServerCOM::OnLineUnRegisterTrying(LPCTSTR sLineName) {}
void CVaxServerCOM::OnLineUnRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnLineUnRegisterSuccess(LPCTSTR sLineName) {}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnOutgoingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sToIP, LONG nToPort) {}
void CVaxServerCOM::OnIncomingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sFromIP, LONG nFromPort) {}

void CVaxServerCOM::OnVaxServerTick(LONG nTickId) {}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnCallSessionRecordedWaveREC(LONG nSessionId, char* pDataREC, LONG nSizeREC, LONG nTypeREC) {}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnCallSessionErrorLog(LONG nSessionId, LONG nErrorCode, LPCTSTR sErrorMsg) {}
void CVaxServerCOM::OnVaxErrorLog(LPCTSTR sFuncName, LONG nErrorCode, LPCTSTR sErrorMsg) {}
	
void CVaxServerCOM::OnVaxLicenseChannel(LONG nTotalChannels, LONG nUsedChannels) {}
void CVaxServerCOM::OnCallSessionAccessAudioPCM(LONG nSessionId, LONG nAccessType, char* pDataPCM, LONG nSizePCM, LONG nTypePCM) {}

//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnAttackDetectedScanSIP(LPCTSTR sReqMethod, LPCTSTR sAddrIP, LONG nAddrPort, LONG nAddrType) {}
void CVaxServerCOM::OnAttackDetectedFloodSIP(LPCTSTR sAddrIP, LONG nAddrPort, LONG nAddrType) {}
void CVaxServerCOM::OnAttackDetectedBruteForceSIP(LPCTSTR sReqMethod, LONG nAuthFailureCount, LPCTSTR sAddrIP, LONG nAddrPort, LONG nAddrType) {}

void CVaxServerCOM::OnCallSessionMediaDetectStartedVAD(LONG nSessionId) {}
void CVaxServerCOM::OnCallSessionMediaDetectCompletedVAD(LONG nSessionId, char* pDataPCM, LONG nSizePCM, LONG nTypePCM) {}
void CVaxServerCOM::OnCallSessionMediaDetectExpiredVAD(LONG nSessionId) {}