#include "StdAfx.h"

#include "VaxCallSession.h"
#include "VaxServerREC.h"

#include "GenFileLoc.h"

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

CVaxCallSession::CVaxCallSession()
{
	
}

CVaxCallSession::~CVaxCallSession()
{

}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CVaxCallSession::OnCallSessionCreated(LONG nSessionId, LONG nReasonCode)
{
	CVaxAccessAudioPCM::OnCallSessionCreated(nSessionId);
}

void CVaxCallSession::OnCallSessionClosed(LONG nSessionId, LONG nReasonCode)
{
	CVaxAccessAudioPCM::OnCallSessionClosed(nSessionId);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CVaxCallSession::StartRecording(LONG nSessionId)
{
	CGenFileLoc objGenFileLoc;
	CString sRecFilePath = objGenFileLoc.GenRecordingFilePath(nSessionId, CVaxServerREC::m_pVaxREC->GetRecordingFolder());

	if(sRecFilePath.IsEmpty())
	{
		CString sErrorMsg;
		sErrorMsg.Format("[SessionId: %d] [Error Msg: %s]", nSessionId, VAX_ERROR_REC_FILE_NOT_FOUND);

		CVaxServerREC::m_pVaxREC->GenStatusLog(sErrorMsg);
		return;
	}
		
	CVaxServerREC::m_pVaxREC->RecordWaveStartToCallSession(nSessionId, sRecFilePath);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CVaxCallSession::OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sCalleeName, LPCTSTR sCalleeId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sUserAgent, LPCTSTR sRecXML, LPCTSTR sFromIP, UINT nFromPort)
{
	CVaxServerREC::m_pVaxREC->AcceptCallSession(nSessionId);
}

void CVaxCallSession::OnCallSessionConnected(LONG nSessionId)
{
	StartRecording(nSessionId);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CVaxCallSession::OnCallSessionAccessAudioPCM(LONG nSessionId, LONG nAccessType, char* pDataPCM, LONG nSizePCM, LONG nTypePCM)
{
	CVaxAccessAudioPCM::OnCallSessionAccessAudioPCM(nSessionId, nAccessType, pDataPCM, nSizePCM);
}