#pragma once

#include "VaxServerCOM.h"

class CStatusLogDlg;
class CVaxCallSessionList;

class CVaxServerREC : public CVaxServerCOM
{

public:
	
	CVaxServerREC();
	~CVaxServerREC();

public:

	CStatusLogDlg* m_pStatusLogDlg;

public:
		
	static CVaxServerREC* m_pVaxREC;

private:

	BOOL m_bInitialized;
	CString m_sRecordingPath;

private:
	
	CVaxCallSessionList* m_pSessionList;
						
private:

	void ResetAll(BOOL bAlloc, BOOL bDeAlloc);

public:
					
	BOOL StartServer(LONG nListenPort);
	void StopServer();
	
	BOOL IsInitialized();
	BOOL AcceptCallSession(LONG nSessionId);
						
	void GenStatusLog(LPCTSTR sStatus);

	void SetRecordingFolder(LPCTSTR sPath);
	CString GetRecordingFolder();

	BOOL RecordWaveStartToCallSession(LONG nSessionId, LPCTSTR sFileName);
					
private:

	void OnRegisterUser(LPCTSTR sUserName, LPCTSTR sDomain, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnRegisterUserSuccess(LPCTSTR sUserName, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnRegisterUserFailed(LPCTSTR sUserName, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnUnRegisterUser(LPCTSTR sUserName);
		
	void OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sCalleeName, LPCTSTR sCalleeId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sUserAgent, LPCTSTR sRecXML, LPCTSTR sFromIP, UINT nFromPort);

	void OnCallSessionConnected(LONG nSessionId);

	void OnCallSessionCreated(LONG nSessionId, LONG nReasonCode);
	void OnCallSessionClosed(LONG nSessionId, LONG nReasonCode);
		
	void OnLineRegisterTrying(LPCTSTR sLineName);
	void OnLineRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnLineRegisterSuccess(LPCTSTR sLineName);
		
	void OnCallSessionErrorLog(LONG nSessionId, LONG nErrorCode, LPCTSTR sErrorMsg);
	void OnVaxErrorLog(LPCTSTR sFuncName, LONG nErrorCode, LPCTSTR sErrorMsg);

	void OnCallSessionAccessAudioPCM(LONG nSessionId, LONG nAccessType, char* pDataPCM, LONG nSizePCM, LONG nTypePCM);
						
protected:

	void OnInitialize();
	void OnStatusLog(LPCTSTR sMsg);
};


