
#pragma once

class CVaxUserList;

class CVaxUser : public CVaxHashTextData
{

public:

	CVaxUser(LPCTSTR sUserName);
	~CVaxUser();

private:

	static CVaxUserList* m_pUserList;
	static LONG m_nRegisterUserCount;

private:
			
	BOOL m_bRegistered;
		
private:

	void OnRegister(LPCTSTR sUserName, LONG nRegId);
	void OnRegisterSuccess(LPCTSTR sUserName);
	void OnRegisterFailed(LPCTSTR sUserName);
	void OnUnRegister(LPCTSTR sUserName);

public:

	static void OnRegisterUser(LPCTSTR sUserName, LPCTSTR sDomain, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	static void OnRegisterUserSuccess(LPCTSTR sUserName, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	static void OnRegisterUserFailed(LPCTSTR sUserName, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	static void OnUnRegisterUser(LPCTSTR sUserName);

private:

	static CVaxUser* GetUser(LPCTSTR sUserName);

public:

	static void ResetAll(BOOL bAlloc, BOOL bDeAlloc);

	static BOOL AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sAudioCodecList);
	static void RemoveUser(LPCTSTR sUserName);
	static void LoadUser();
		
	static LONG GetRegisteredUserCount();
};

