﻿using System;
using System.Runtime.InteropServices;
using VaxTeleServerRECLib;

public class cVaxServerCOM
{
    public const int SIP_DEFAULT_PORT = 6080;
        
    public const int VAX_PEER_TYPE_USER = 0;
    public const int VAX_PEER_TYPE_LINE = 1;

    public const int VAX_LINE_TYPE_UDP = 0;
    public const int VAX_LINE_TYPE_TCP = 1;
    public const int VAX_LINE_TYPE_TLS = 2;

    ///////////////////////////////////////////////////////////

    public const int VAX_WAVE_REC_TYPE_MONO_PCM = 0;
    public const int VAX_WAVE_REC_TYPE_STEREO_PCM = 1;
    public const int VAX_WAVE_REC_TYPE_MONO_G711U = 2;
    public const int VAX_WAVE_REC_TYPE_STEREO_G711U = 3;
    public const int VAX_WAVE_REC_TYPE_MONO_G711A = 4;
    public const int VAX_WAVE_REC_TYPE_STEREO_G711A = 5;
    
    ///////////////////////////////////////////////////////////
        
    public const int VAX_CODEC_GSM610 = 0;
    public const int VAX_CODEC_ILBC = 1;
    public const int VAX_CODEC_G711A = 2;
    public const int VAX_CODEC_G711U = 3;
    public const int VAX_CODEC_G729 = 4;

    public const int VAX_CODEC_TOTAL_COUNT = 5;
        
    ///////////////////////////////////////////////////////////

    public const int VAX_CUSTOM_HEADER_REQ_ID_INVITE = 0;

    ///////////////////////////////////////////////////////////

    public const int VAX_CLOSED_REASON_CODE_HANGUP = 0;
    public const int VAX_CLOSED_REASON_CODE_SESSION_LOST = 1;
    public const int VAX_CLOSED_REASON_CODE_MOVED = 2;
    public const int VAX_CLOSED_REASON_CODE_TRANSFERED = 3;
    public const int VAX_CLOSED_REASON_CODE_REJECTED = 4;
    public const int VAX_CLOSED_REASON_CODE_FAILED = 5;
    public const int VAX_CLOSED_REASON_CODE_CANCELLED = 6;
    public const int VAX_CLOSED_REASON_CODE_TIMEOUT = 7;
    public const int VAX_CLOSED_REASON_CODE_CLOSED = 8;

    ////////////////////////////////////////////////////////////////

    public const int VAX_ACCESS_PCM_TYPE_ALL_NONE = -1;
    public const int VAX_ACCESS_PCM_TYPE_EVENT_NONE = 0;
    public const int VAX_ACCESS_PCM_TYPE_EVENT_MEDIA_ZERO = 1;
    public const int VAX_ACCESS_PCM_TYPE_EVENT_MEDIA_ONE = 2;
    public const int VAX_ACCESS_PCM_TYPE_PIPE_NONE = 3;
    public const int VAX_ACCESS_PCM_TYPE_PIPE_MEDIA_ZERO = 4;
    public const int VAX_ACCESS_PCM_TYPE_PIPE_MEDIA_ONE = 5;

    public const int VAX_MEDIA_DETECT_VAD_TYPE_ZERO = 0;
    public const int VAX_MEDIA_DETECT_VAD_TYPE_ONE = 1;

    ///////////////////////////////////////////////////////////

    private VaxServerREC m_objVaxServerREC = new VaxServerREC();

    public cVaxServerCOM()
    {

        m_objVaxServerREC.OnUnRegisterUser += new _IVaxServerRECEvents_OnUnRegisterUserEventHandler(OnUnRegisterUser);
        m_objVaxServerREC.OnRegisterUser += new _IVaxServerRECEvents_OnRegisterUserEventHandler(OnRegisterUser);
        
        m_objVaxServerREC.OnRegisterUserFailed += new _IVaxServerRECEvents_OnRegisterUserFailedEventHandler(OnRegisterUserFailed);
        m_objVaxServerREC.OnRegisterUserSuccess += new _IVaxServerRECEvents_OnRegisterUserSuccessEventHandler(OnRegisterUserSuccess);
        
        m_objVaxServerREC.OnLineRegisterTrying += new _IVaxServerRECEvents_OnLineRegisterTryingEventHandler(OnLineRegisterTrying);
        m_objVaxServerREC.OnLineRegisterFailed += new _IVaxServerRECEvents_OnLineRegisterFailedEventHandler(OnLineRegisterFailed);
        m_objVaxServerREC.OnLineRegisterSuccess += new _IVaxServerRECEvents_OnLineRegisterSuccessEventHandler(OnLineRegisterSuccess);

        m_objVaxServerREC.OnLineUnRegisterTrying += new _IVaxServerRECEvents_OnLineUnRegisterTryingEventHandler(OnLineUnRegisterTrying);
        m_objVaxServerREC.OnLineUnRegisterFailed += new _IVaxServerRECEvents_OnLineUnRegisterFailedEventHandler(OnLineUnRegisterFailed);
        m_objVaxServerREC.OnLineUnRegisterSuccess += new _IVaxServerRECEvents_OnLineUnRegisterSuccessEventHandler(OnLineUnRegisterSuccess);
                
        m_objVaxServerREC.OnIncomingCall += new _IVaxServerRECEvents_OnIncomingCallEventHandler(OnIncomingCall);
        m_objVaxServerREC.OnCallSessionConnected += new _IVaxServerRECEvents_OnCallSessionConnectedEventHandler(OnCallSessionConnected);
        m_objVaxServerREC.OnCallSessionClosed += new _IVaxServerRECEvents_OnCallSessionClosedEventHandler(OnCallSessionClosed);

        m_objVaxServerREC.OnCallSessionLost += new _IVaxServerRECEvents_OnCallSessionLostEventHandler(OnCallSessionLost);
        m_objVaxServerREC.OnCallSessionHangup += new _IVaxServerRECEvents_OnCallSessionHangupEventHandler(OnCallSessionHangup);
        m_objVaxServerREC.OnCallSessionTimeout += new _IVaxServerRECEvents_OnCallSessionTimeoutEventHandler(OnCallSessionTimeout);
        m_objVaxServerREC.OnCallSessionCancelled += new _IVaxServerRECEvents_OnCallSessionCancelledEventHandler(OnCallSessionCancelled);
                
        m_objVaxServerREC.OnOutgoingDiagnosticLog += new _IVaxServerRECEvents_OnOutgoingDiagnosticLogEventHandler(OnOutgoingDiagnosticLog);
        m_objVaxServerREC.OnIncomingDiagnosticLog += new _IVaxServerRECEvents_OnIncomingDiagnosticLogEventHandler(OnIncomingDiagnosticLog);
                
        m_objVaxServerREC.OnVaxServerTick += new _IVaxServerRECEvents_OnVaxServerTickEventHandler(OnVaxServerTick);
        m_objVaxServerREC.OnCallSessionCreated += new _IVaxServerRECEvents_OnCallSessionCreatedEventHandler(OnCallSessionCreated);
        m_objVaxServerREC.OnCallSessionRecordedWaveREC += new _IVaxServerRECEvents_OnCallSessionRecordedWaveRECEventHandler(OnCallSessionRecordedWaveREC);

        m_objVaxServerREC.OnVaxErrorLog += new _IVaxServerRECEvents_OnVaxErrorLogEventHandler(OnVaxErrorLog);
        m_objVaxServerREC.OnCallSessionErrorLog += new _IVaxServerRECEvents_OnCallSessionErrorLogEventHandler(OnCallSessionErrorLog);
        m_objVaxServerREC.OnCallSessionAccessAudioPCM += new _IVaxServerRECEvents_OnCallSessionAccessAudioPCMEventHandler(OnCallSessionAccessAudioPCM);

        m_objVaxServerREC.OnAttackDetectedScanSIP += new _IVaxServerRECEvents_OnAttackDetectedScanSIPEventHandler(OnAttackDetectedScanSIP);
        m_objVaxServerREC.OnAttackDetectedFloodSIP += new _IVaxServerRECEvents_OnAttackDetectedFloodSIPEventHandler(OnAttackDetectedFloodSIP);
        m_objVaxServerREC.OnAttackDetectedBruteForceSIP += new _IVaxServerRECEvents_OnAttackDetectedBruteForceSIPEventHandler(OnAttackDetectedBruteForceSIP);

        m_objVaxServerREC.OnCallSessionMediaDetectStartedVAD += new _IVaxServerRECEvents_OnCallSessionMediaDetectStartedVADEventHandler(OnCallSessionMediaDetectStartedVAD);
        m_objVaxServerREC.OnCallSessionMediaDetectCompletedVAD += new _IVaxServerRECEvents_OnCallSessionMediaDetectCompletedVADEventHandler(OnCallSessionMediaDetectCompletedVAD);
        m_objVaxServerREC.OnCallSessionMediaDetectExpiredVAD += new _IVaxServerRECEvents_OnCallSessionMediaDetectExpiredVADEventHandler(OnCallSessionMediaDetectExpiredVAD);
    }
        
    #region Methods

    public String GetVersionSDK()
    {
        return m_objVaxServerREC.GetVersionSDK();
    }

    public String GetVersionFile()
    {
        return m_objVaxServerREC.GetVersionFile();
    }

    public void SetLicenseKey(String sLicenseKey)
    {
        m_objVaxServerREC.SetLicenseKey(sLicenseKey);
    }

    public Boolean Initialize(String sDomainRealm)
    {
        return m_objVaxServerREC.Initialize(sDomainRealm);
    }

    public void UnInitialize()
    {
        m_objVaxServerREC.UnInitialize();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////
    
    public Boolean CryptoMediaNONE(Boolean bForced)
    {
        return m_objVaxServerREC.CryptoMediaNONE(bForced);
    }

    public Boolean CryptoMediaSDP(Boolean bForced)
    {
        return m_objVaxServerREC.CryptoMediaSDP(bForced);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////

    public Boolean OpenNetworkUDP(String sListenIP, int nListenPort)
    {
        return m_objVaxServerREC.OpenNetworkUDP(sListenIP, nListenPort);
    }

    public Boolean OpenNetworkTCP(String sListenIP, int nListenPort)
    {
        return m_objVaxServerREC.OpenNetworkTCP(sListenIP, nListenPort);
    }

    public Boolean OpenNetworkTLS(String sListenIP, int nListenPort, String sCertPEM)
    {
        return m_objVaxServerREC.OpenNetworkTLS(sListenIP, nListenPort, sCertPEM);
    }

    public void CloseNetworkUDP()
    {
        m_objVaxServerREC.CloseNetworkUDP();
    }

    public void CloseNetworkTCP()
    {
        m_objVaxServerREC.CloseNetworkTCP();
    }

    public void CloseNetworkTLS()
    {
        m_objVaxServerREC.CloseNetworkTLS();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////

    public Boolean SetListenPortRangeRTP(int nListenStartPort, int nListenEndPort)
    {
        return m_objVaxServerREC.SetListenPortRangeRTP(nListenStartPort, nListenEndPort);
    }

    public Boolean SetNetworkMediaRTP(String sListenIP, int nListenStartPort)
    {
        return m_objVaxServerREC.SetNetworkMediaRTP(sListenIP, nListenStartPort);
    }
        
    /////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////

    public Boolean AddUser(String sUserName, String sPassword, String sAudioCodecList)
    {
        return m_objVaxServerREC.AddUser(sUserName, sPassword, sAudioCodecList);
    }

    public void RemoveUser(String sUserName)
    {
        m_objVaxServerREC.RemoveUser(sUserName);
    }

    public Boolean AcceptRegister(int nRegId)
    {
        return m_objVaxServerREC.AcceptRegister(nRegId);
    }
    public Boolean RejectRegister(int nRegId, int nStatusCode, String sReasonPhrase)
    {
        return m_objVaxServerREC.RejectRegister(nRegId, nStatusCode, sReasonPhrase);
    }

    public Boolean AttachRegister(int nRegId, String sUserName)
    {
        return m_objVaxServerREC.AttachRegister(nRegId, sUserName);
    }

    public Boolean AuthRegister(int nRegId)
    {
        return m_objVaxServerREC.AuthRegister(nRegId);
    }

    public Boolean RegisterUserExpiry(int nExpiry)
    {
        return m_objVaxServerREC.RegisterUserExpiry(nExpiry);
    }
        
    /////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////

    public Boolean AddLine(String sLineName, int nLineType, String sDisplayName, String sUserName, String sAuthUser, String sAuthPwd, String sDomainRealm, String sServerAddr, int nServerPort, String sAudioCodecList)
    {
        return m_objVaxServerREC.AddLine(sLineName, nLineType, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sServerAddr, nServerPort, sAudioCodecList);
    }

    public void RemoveLine(String sLineName)
    {
        m_objVaxServerREC.RemoveLine(sLineName);
    }

    public Boolean RegisterLine(String sLineName, int nExpire)
    {
        return m_objVaxServerREC.RegisterLine(sLineName, nExpire);
    }
    public Boolean UnRegisterLine(String sLineName)
    {
        return m_objVaxServerREC.UnRegisterLine(sLineName);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////
        public Boolean AcceptCallSession(int nSessionId, int nTimeout)
    {
        return m_objVaxServerREC.AcceptCallSession(nSessionId, nTimeout);
    }

    public Boolean RejectCallSession(int nSessionId, int nStatusCode, String sReasonPhrase)
    {
        return m_objVaxServerREC.RejectCallSession(nSessionId, nStatusCode, sReasonPhrase);
    }

    public Boolean CloseCallSession(int nSessionId)
    {
        return m_objVaxServerREC.CloseCallSession(nSessionId);
    }
        
    /////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////

    public Boolean RecordWaveSetCacheSize(int nCacheSize)
    {
        return m_objVaxServerREC.RecordWaveSetCacheSize(nCacheSize);
    }
   
    public Boolean RecordWaveStartToCallSession(int nSessionId, String sFileName, int nTypeREC)
    {
        return m_objVaxServerREC.RecordWaveStartToCallSession(nSessionId, sFileName, nTypeREC);
    }

    public void RecordWaveStopToCallSession(int nSessionId)
    {
        m_objVaxServerREC.RecordWaveStopToCallSession(nSessionId);
    }

    public Boolean RecordWavePauseToCallSession(int nSessionId, Boolean bEnable)
    {
        return m_objVaxServerREC.RecordWavePauseToCallSession(nSessionId, bEnable);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////
        
    public Boolean AudioSessionLost(Boolean bEnable, int nTimeout)
    {
        return m_objVaxServerREC.AudioSessionLost(bEnable, nTimeout);
    }

    public Boolean VaxServerStartTick(int nTickId, int nElapse)
    {
        return m_objVaxServerREC.VaxServerStartTick(nTickId, nElapse);
    }
    public Boolean VaxServerStopTick(int nTickId)
    {
        return m_objVaxServerREC.VaxServerStopTick(nTickId);
    }

    public Boolean SetUserAgentName(String sName)
    {
        return m_objVaxServerREC.SetUserAgentName(sName);
    }
    public String GetUserAgentName()
    {
        return m_objVaxServerREC.GetUserAgentName().ToString();
    }

    public Boolean SetSessionNameSDP(String sName)
    {
        return m_objVaxServerREC.SetSessionNameSDP(sName);
    }
    public String GetSessionNameSDP()
    {
        return m_objVaxServerREC.GetSessionNameSDP().ToString();
    }
        
    public int GetVaxErrorCode()
    {
        return m_objVaxServerREC.GetVaxErrorCode();
    }
        
    public Boolean DiagnosticLogSIP(Boolean bInbound, Boolean bOutbound)
    {
        return m_objVaxServerREC.DiagnosticLogSIP(bInbound, bOutbound);
    }
    
    public Boolean CallSessionSendStatusResponse(int nSessionId, int nStatusCode, String sReasonPhrase, String sContactURI)
    {
        return m_objVaxServerREC.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, sContactURI);
    }

    public Boolean AddCustomHeader(int nReqId, String sName, String sValue)
    {
        return m_objVaxServerREC.AddCustomHeader(nReqId, sName, sValue);
    }

    public Boolean RemoveCustomHeader(int nReqId, String sName)
    {
        return m_objVaxServerREC.RemoveCustomHeader(nReqId, sName);
    }

    public Boolean RemoveCustomHeaderAll(int nReqId)
    {
        return m_objVaxServerREC.RemoveCustomHeaderAll(nReqId);
    }

    /////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public int GetCallSessionTxCodec(int nSessionId)
    {
        return m_objVaxServerREC.GetCallSessionTxCodec(nSessionId);
    }

    public int GetCallSessionRxCodec(int nSessionId)
    {
        return m_objVaxServerREC.GetCallSessionRxCodec(nSessionId);
    }

    ////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public int GetCallCount()
    {
        return m_objVaxServerREC.GetCallCount();
    }

    ////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////

    public String GetCallSessionHeaderCallId(int nSessionId)
    {
        return m_objVaxServerREC.GetCallSessionHeaderCallId(nSessionId);
    }

    public Boolean CallSessionMuteVoice(int nSessionId, Boolean bListen, Boolean bSpeak)
    {
        return m_objVaxServerREC.CallSessionMuteVoice(nSessionId, bListen, bSpeak);
    }

    public Boolean AddNetworkRouteSIP(String sAssignedIP, String sRouterIP)
    {
        return m_objVaxServerREC.AddNetworkRouteSIP(sAssignedIP, sRouterIP);
    }

    public Boolean AddNetworkRouteRTP(String sAssignedIP, String sRouterIP)
    {
        return m_objVaxServerREC.AddNetworkRouteRTP(sAssignedIP, sRouterIP);
    }

    //////////////////////////////////////////////////////////////////////////////

    public Boolean AccessAudioPCM(int nSessionId, String sPipeName, int nAccessType)
    {
        return m_objVaxServerREC.AccessAudioPCM(nSessionId, sPipeName, nAccessType);
    }

    //////////////////////////////////////////////////////////////////////////////
    public Boolean AttackDetectScanSIP(String sDomainName)
    {
        return m_objVaxServerREC.AttackDetectScanSIP(sDomainName);
    }

    public Boolean AttackDetectFloodSIP(int nReqRecvLimit)
    {
        return m_objVaxServerREC.AttackDetectFloodSIP(nReqRecvLimit);
    }

    public Boolean AttackDetectBruteForceSIP(int nFailureCount, int nFailureInterval)
    {
        return m_objVaxServerREC.AttackDetectBruteForceSIP(nFailureInterval, nFailureInterval);
    }

    //////////////////////////////////////////////////////////////////////////////
    public Boolean DetectStartVAD(int nSessionId, int nAudioLevelVU, int nSilenceLengthPCM, int nSilenceCountPCM, int nAnalysisLengthPCM, int nExpiryLengthPCM, int nProcessLengthPCM, int nDetectType)
    {
        return m_objVaxServerREC.DetectStartVAD(nSessionId, nAudioLevelVU, nSilenceLengthPCM, nSilenceCountPCM, nAnalysisLengthPCM, nExpiryLengthPCM, nProcessLengthPCM, nDetectType);
    }
    public void DetectStopVAD(int nSessionId)
    {
        m_objVaxServerREC.DetectStopVAD(nSessionId);
    }

    //////////////////////////////////////////////////////////////////////////////

    #endregion


    #region Events

    protected virtual void OnUnRegisterUser(String sUserName)
    {
    }
    protected virtual void OnRegisterUser(String sUserName, String sDomain, String sUserAgentName, String sFromIP, int nFromPort, int nRegId)
    {
    }

    protected virtual void OnRegisterUserFailed(String sUserName, String sFromIP, int nFromPort, int nRegId)
    {
    }

    protected virtual void OnRegisterUserSuccess(String sUserName, String sFromIP, int nFromPort, int nRegId)
    {
    }
    

    protected virtual void OnLineRegisterTrying(String sLineName)
    {
    }
    protected virtual void OnLineRegisterFailed(String sLineName, int nStatusCode, String sReasonPhrase)
    {
    }
    protected virtual void OnLineRegisterSuccess(String sLineName)
    {
    }
    protected virtual void OnLineUnRegisterTrying(String sLineName)
    {
    }
    protected virtual void OnLineUnRegisterFailed(String sLineName, int nStatusCode, String sReasonPhrase)
    {
    }
    protected virtual void OnLineUnRegisterSuccess(String sLineName)
    {
    }

    protected virtual void OnIncomingCall(int nSessionId, String sCallerName, String sCallerId, String sCalleeName, String sCalleeId, String sDialNo, int nFromPeerType, String sFromPeerName, String sUserAgentName, String sRecXML, String sFromIP, int nFromPort)
    {
    }
        
    protected virtual void OnCallSessionConnected(int nSessionId)
    {
    }
    protected virtual void OnCallSessionClosed(int nSessionId, int nReasonCode)
    {
    }

    protected virtual void OnCallSessionLost(int nSessionId)
    {
    }

    protected virtual void OnCallSessionHangup(int nSessionId)
    {
    }

    protected virtual void OnCallSessionTimeout(int nSessionId)
    {
    }

    protected virtual void OnCallSessionCancelled(int nSessionId)
    {
    }
        
    ////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////////

    protected virtual void OnOutgoingDiagnosticLog(String sMsgSIP, String sToIP, int nToPort)
    {
    }
    protected virtual void OnIncomingDiagnosticLog(String sMsgSIP, String sFromIP, int nFromPort)
    {
    }

    protected virtual void OnVaxServerTick(int nTickId)
    {
    }
        
    protected virtual void OnCallSessionCreated(int nSessionId, int nReasonCode)
    {

    }
        
    private void OnCallSessionRecordedWaveREC(int nSessionId, long lDataREC, int nSizeREC, int nTypeREC)
    {
        Byte[] aDataREC = new byte[nSizeREC];
        Marshal.Copy(new IntPtr(lDataREC), aDataREC, 0, nSizeREC);

        OnCallSessionRecordedWaveREC(nSessionId, aDataREC, nSizeREC, nTypeREC);
    }

    protected virtual void OnCallSessionRecordedWaveREC(int nSessionId, Byte[] aDataREC, int nSizeREC, int nTypeREC)
    {

    }
    
    //////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////

    private void OnCallSessionAccessAudioPCM(int nSessionId, int nAccessType, long lDataPCM, int nSizePCM, int nTypePCM)
    {
        Byte[] aDataPCM = new byte[nSizePCM];
        Marshal.Copy(new IntPtr(lDataPCM), aDataPCM, 0, nSizePCM);

        OnCallSessionAccessAudioPCM(nSessionId, nAccessType, aDataPCM, nSizePCM, nTypePCM);
    }
        
    protected virtual void OnCallSessionAccessAudioPCM(int nSessionId, int nAccessType, Byte[] aDataPCM, int nSizePCM, int nTypePCM)
    {

    }

    //////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////

    protected virtual void OnVaxErrorLog(String sFuncName, int nErrorCode, String sErrorMsg)
    {

    }

    protected virtual void OnCallSessionErrorLog(int nSessionId, int nErrorCode, String sErrorMsg)
    {
        
    }

    //////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////
    protected virtual void OnAttackDetectedScanSIP(String sReqMethod, String sAddrIP, int nAddrPort, int nAddrType)
    {

    }

    protected virtual void OnAttackDetectedFloodSIP(String sAddrIP, int nAddrPort, int nAddrType)
    {

    }

    protected virtual void OnAttackDetectedBruteForceSIP(String sReqMethod, int nAuthFailureCount, String sAddrIP, int nAddrPort, int nAddrType)
    {
    }

    //////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////
    private void OnCallSessionMediaDetectCompletedVAD(int nSessionId, long lDataPCM, int nSizePCM, int nTypePCM)
    {
        Byte[] aDataPCM = new byte[nSizePCM];
        Marshal.Copy(new IntPtr(lDataPCM), aDataPCM, 0, nSizePCM);

        OnCallSessionMediaDetectCompletedVAD(nSessionId, aDataPCM, nSizePCM, nTypePCM);
    }

    protected virtual void OnCallSessionMediaDetectStartedVAD(int nSessionId)
    {

    }

    protected virtual void OnCallSessionMediaDetectCompletedVAD(int nSessionId, Byte[] aDataPCM, int nSizePCM, int nTypePCM)
    {

    }

    protected virtual void OnCallSessionMediaDetectExpiredVAD(int nSessionId)
    {

    }

    #endregion

}

