﻿using System;

namespace ServerREC
{
    class cVaxCallSession
    {
        cVaxAccessAudioPCM m_objAccessPCM = null;
        cVaxDetectAudioVAD m_objDetectVAD = null;

        public cVaxCallSession()
        {
            m_objAccessPCM = new cVaxAccessAudioPCM();
            m_objDetectVAD = new cVaxDetectAudioVAD();
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////
               
        public void OnCallSessionClosed(int nSessionId, int nReasonCode)
        {
            m_objAccessPCM.OnCallSessionClosed(nSessionId);
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////
                
        public void OnIncomingCall(int nSessionId, String sCallerName, String sCallerId, String sCalleeName, String sCalleeId, String sDialNo, int nFromPeerType, String sFromPeerName, String sUserAgentName, String sRecXML, String sFromIP, int nFromPort)
        {
            AcceptCallSession(nSessionId);
        }

        private Boolean AcceptCallSession(int nSessionId)
        {
            bool bResult = cVaxServerREC.mVaxREC.AcceptCallSession(nSessionId);

            if (!bResult)
            {
                cVaxServerREC.mVaxREC.RejectCallSession(nSessionId, 404, "Not Found");
                return false;
            }

            return true;
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public void OnCallSessionConnected(int nSessionId)
        {
            StartRecording(nSessionId);

            m_objAccessPCM.OnCallSessionConnected(nSessionId);
            m_objDetectVAD.OnCallSessionConnected(nSessionId);
        }

        private void StartRecording(int nSessionId)
        {
            string sDefaultRecPath = cVaxServerREC.mVaxREC.GetRecordingFolder();

            cGenFileLocation objGenFileLoc = new cGenFileLocation();
            string sRecFilePath = objGenFileLoc.GenRecordingFilePath(nSessionId, sDefaultRecPath);

            if (sRecFilePath.Length == 0)
            {
                string sErrorMsg = string.Format("[SessionId:{0}] [Error Msg: {1}]", nSessionId, cVaxDefine.ERROR_REC_FILE_NOT_FOUND);
                cVaxServerREC.mVaxREC.GenStatusLog(sErrorMsg);

                return;
            }

            cVaxServerREC.mVaxREC.RecordWaveStartToCallSession(nSessionId, sRecFilePath);
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public void OnCallSessionAccessAudioPCM(int nSessionId, int nAccessType, Byte[] aDataPCM, int nSizePCM)
        {
            m_objAccessPCM.OnCallSessionAccessAudioPCM(nSessionId, nAccessType, aDataPCM, nSizePCM);
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public void OnCallSessionMediaDetectStartedVAD(int nSessionId)
        {
            m_objDetectVAD.OnCallSessionMediaDetectStartedVAD(nSessionId);
        }

        public void OnCallSessionMediaDetectCompletedVAD(int nSessionId, Byte[] aDataPCM, int nSizePCM, int nTypePCM)
        {
            m_objDetectVAD.OnCallSessionMediaDetectCompletedVAD(nSessionId, aDataPCM, nSizePCM, nTypePCM);
        }

        public void OnCallSessionMediaDetectExpiredVAD(int nSessionId)
        {
            m_objDetectVAD.OnCallSessionMediaDetectExpiredVAD(nSessionId);
        }
    }
}
