﻿using System;
using System.Collections;

namespace ServerREC
{
    class cVaxLine
    {
        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public static void OnLineRegisterTrying(String sLineName)
        {
            String sStatus = sLineName + " " + cVaxDefine.LINE_REG_TRYING;
            cVaxServerREC.mVaxREC.GenStatusLog(sStatus);
        }

        public static void OnLineRegisterFailed(String sLineName, int nStatusCode, String sReasonPhrase)
        {
            String sStatus = sLineName + " Register Failed: " + sReasonPhrase;
            cVaxServerREC.mVaxREC.GenStatusLog(sStatus);
        }

        public static void OnLineRegisterSuccess(String sLineName)
        {
            String sStatus = sLineName + " " + cVaxDefine.LINE_REG_SUCCESS;
            cVaxServerREC.mVaxREC.GenStatusLog(sStatus);
        }
                               
        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public static Boolean AddLine(String sLineName, int nLineType, String sAuthUser, String sAuthPwd, String sServerAddr, int nServerPort, String sAudioCodecList, Boolean bRegister)
        {
            if (cVaxServerREC.mVaxREC.IsInitialized() == false || (sLineName.Length == 0))
                return false;

            RemoveLine(sLineName);

            if (!cVaxServerREC.mVaxREC.AddLine(sLineName, nLineType, "", "", sAuthUser, sAuthPwd, "", sServerAddr, nServerPort, sAudioCodecList))
                return false;
                                                
            if (bRegister)
                cVaxServerREC.mVaxREC.RegisterLine(sLineName, 1800);
            
            cStoreLine.AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister);
            return true;
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public static void RemoveLine(String sLineName)
        {
            if (cVaxServerREC.mVaxREC.IsInitialized() == false || (sLineName.Length == 0))
                return;

            cVaxServerREC.mVaxREC.RemoveLine(sLineName);
            cStoreLine.RemoveLine(sLineName);
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public static void LoadLine()
        {
            if (!cVaxServerREC.mVaxREC.IsInitialized())
                return;

            ArrayList objListLines = new ArrayList();
            cStoreLine.GetLineNameAll(ref objListLines);

            if (objListLines.Count == 0)
                return;

            String sAuthUser = "", sAuthPwd = "", sServerAddr = "", sAudioCodecList = "";
            Boolean bRegister = false;

            int nLineType = cVaxServerCOM.VAX_LINE_TYPE_UDP, nServerPort = cVaxServerCOM.SIP_DEFAULT_PORT;

            foreach (String sLineName in objListLines)
            {
                cStoreLine.GetLine(sLineName, ref nLineType, ref sAuthUser, ref sAuthPwd, ref sServerAddr, ref nServerPort, ref sAudioCodecList, ref bRegister);
                AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister);

            }
        }
    }
}
