﻿using System;
using System.Collections;

namespace ServerREC
{
    class cStoreUser
    {
        const String USER_ROOT_PATH = "Users\\";
                 
        /////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////

        public static Boolean AddUser(String sUserName, String sPassword, String sAudioCodecList)
        {
            if(sUserName.Length == 0)
                return false;

            String sKeyPath = USER_ROOT_PATH + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.SetTEXT(sKeyPath, "UserName", sUserName);
            objStore.SetTEXT(sKeyPath, "Password", sPassword);

            objStore.SetTEXT(sKeyPath, "AudioCodecList", sAudioCodecList);
                        
            objStore.Close();
                        
            return true;
        }

        public static void GetUser(String sUserName, ref String sPassword, ref String sAudioCodecList)
        {
            String sKeyPath = USER_ROOT_PATH + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();
                       
            objStore.GetTEXT(sKeyPath, "Password", ref sPassword, "");
            objStore.GetTEXT(sKeyPath, "AudioCodecList", ref sAudioCodecList, "");
                        
            objStore.Close();
        }

        public static void RemoveUser(String sUserName)
        {
            if(sUserName.Length == 0)
                return;

            String sKeyPath = USER_ROOT_PATH + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.DeleteSubKey(sKeyPath);
            objStore.Close();
        }

        public static void GetUserAll(ref ArrayList objList)
        {
            String sKeyPath = USER_ROOT_PATH;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }

        /////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////
                
        public static Boolean IsDataStored()
        {
            cStoreRegistry objStore = new cStoreRegistry();
            Boolean bResult = objStore.IsKeyExist(USER_ROOT_PATH);

            objStore.Close();
            return bResult;
        }
    }
}
